import {
    Component,
    ElementRef,
    EventEmitter,
    OnInit,
    Output
} from '@angular/core';

import { TimeZonePickerService } from '../services/timezonepicker.service';

import { TimeZone } from '../models/timezone';

import * as moment from 'moment-timezone';


@Component({
    selector: 'timezone-picker',
    templateUrl: './timezonepicker.component.html',
    styleUrls: [ './timezonepicker.component.css' ]
})
export class TimeZonePickerComponent implements OnInit {
    allTimeZones: TimeZone[];

    private selectedTimeZoneValue: string;

    @Output() timeZoneChange = new EventEmitter<string>();

    constructor(private service: TimeZonePickerService) {
        this.allTimeZones = service.getTimeZones();
    }

    get selectedTimeZone() {
        return this.selectedTimeZoneValue;
    }

    set selectedTimeZone(value) {
        this.selectedTimeZoneValue = value;
        this.timeZoneChange.emit(value);
    }

    ngOnInit() {
        this.selectedTimeZone = moment.tz.guess();
    }
}
